const {ccclass, property} = cc._decorator;

@ccclass
export class MyWV extends cc.Component {
	@property(cc.WebView)
	wv: cc.WebView = null;

	@property(cc.Label)
	msg: cc.Label = null;

	@property(cc.String)
	webHost: string = "http://10.0.0.12:8080/";

	onLoad() {
		if (this.webHost.length > 0) {
			if (this.webHost[this.webHost.length] != "/")
				this.webHost += "/";
		} else {
			console.error("需加载的容器页地址为空")
			return;
		}

		if (CC_JSB) {
			this.setWVUrl(this.webHost + "webviews/native_test.html");
		}
	}

	public loadTest(): void {
		if (CC_JSB) {
			this.msg.string += "jsb loadTest()\n";
			this.wv.evaluateJS("test()");
		}
	}

	public setWVUrl(url: string): void {
		let handler = new cc.Component.EventHandler();
		handler.target = this.node;
		handler.component = "MyWV";
		handler.handler = "wvLoaded";
		handler.customEventData = "";
		this.wv.webviewEvents.push(handler);

		this.wv.url = url;
	}

	private wvLoaded(wv, et, data) {
		if (et === cc.WebView.EventType.LOADED) {
			this.msg.string += "加载完成\n";
			if (CC_JSB) {
				this.msg.string += "jsb 调用 页面test\n";
				this.wv.evaluateJS("test()");
			}
		} else if (et === cc.WebView.EventType.LOADING) {
			this.msg.string += "加载中\n";
		} else if (et === cc.WebView.EventType.ERROR) {
			console.error("加载时页面出错");
		}
	}
}
